library "Roku_Ads.brs"

' ********** Copyright 2016 Roku Corp.  All Rights Reserved. ********** 

'Roku Advertising Framework for Video Ads Main Entry Point
Sub RunUserInterface(args As Object)

    'Home Screen Initialization 
    ShowHomeListScreen()

End Sub

'Creation and configuration of list screen menu.
Sub ShowHomeListScreen()
    screen = CreateObject("roListScreen")
    port = CreateObject("roMessagePort")
    screen.SetMessagePort(port)
    screen.SetHeader("Roku Advertising Framework for Video Ads")
    screen.SetBreadcrumbText("Nielsen Integration Example", "")
    
    'AA for base video, ad and Nielsen configuration.
    'For additional information please see official RAF documentation.
    videoContent = { 
        streamFormat : "mp4",
        'Lengthy (17 min.) TED talk to allow time for testing ad pods
        stream: {
            url:  "http://video.ted.com/talks/podcast/DavidKelley_2002_480.mp4",
            bitrate: 800,
            quality: false
        }

        'Provider ad url, can be configurable with URL Parameter Macros.
        'Some parameter values can be substituted dinamicly in ad request and tracking URLs.
        'For example: ROKU_ADS_APP_ID - Identifies the client application making the ad request.
        adUrl: "http://1c6e2.v.fwmrm.net/ad/g/1?nw=116450&ssnw=116450&asnw=116450&caid=493509699603&csid=fxn_shows_roku&prof=116450:Fox_Live_Roku&resp=vast&metr=1031&flag=+exvt+emcr+sltp&;_fw_ae=d8b58f7bfce28eefcc1cdd5b95c3b663;app_id=ROKU_ADS_APP_ID",
        VASTUrl : "http://pubads.g.doubleclick.net/gampad/ads?slotname=/82114269/Video/fallbacktest&sz=1920x1080&url=[http://roku.com&unviewed_position_start=1&output=vast&impl=s&env=vp&gdfp_req=1&ad_rule=0&description_url=http%3A%2F%2Fapps.roku.com&vad_type=linear&sdkv=roku&min_ad_duration=0&max_ad_duration=60000&rdid=ROKU_ADS_TRACKING_ID&is_lat=ROKU_ADS_LIMIT_TRACKING&idtype=rida&correlator=ROKU_ADS_TIMESTAMP&scor=ROKU_ADS_TIMESTAMP&pod=POD_NUM&ppos=POD_POSITION&cust_params=genre%3DROKU_ADS_CONTENT_GENRE%26ua%3DROKU_ADS_USER_AGENT%26ai%3DROKU_ADS_APP_ID]http://roku.com&unviewed_position_start=1&output=vast&impl=s&env=vp&gdfp_req=1&ad_rule=0&description_url=http%3A%2F%2Fapps.roku.com&vad_type=linear&sdkv=roku&min_ad_duration=0&max_ad_duration=60000&rdid=ROKU_ADS_TRACKING_ID&is_lat=ROKU_ADS_LIMIT_TRACKING&idtype=rida&correlator=ROKU_ADS_TIMESTAMP&scor=ROKU_ADS_TIMESTAMP&pod=POD_NUM&ppos=POD_POSITION&cust_params=genre%3DROKU_ADS_CONTENT_GENRE%26ua%3DROKU_ADS_USER_AGENT%26ai%3DROKU_ADS_APP_ID"
        contentId: "TED", 'String value representing content to allow potential ad targeting.
        contentGenre: "General Variety", 'Comma-delimited string or array of genre tag strings.
        conntentLength: "1200", 'Integer value representing total length of content (in seconds).
        
        nielsenProgramId: "CBAA", 'String identifying content program for Nielsen DAR tags.
        nielsenAppId: "P2871BBFF-1A28-44AA-AF68-C7DE4B148C32", 'String identifying Nielsen-assigned application ID.
        nielsenGenre: "GV" 'String identifying primary content genre for Nielsen DAR tags.
        
        ' path to the file containing non-standard ads feed
        nonStandardAdsFilePath: "pkg:/feed/ads_nonstandard.json"
        VASTResponseFilePath: "pkg:/feed/VASTResponse.xml"
    }

    'Array of AA for main menu bulding.
    contentList = [
        {
            Title: "Test Stitched Ads: Mixed",
            playWithRaf: TestMixedStitchedAds
        }
    ]
    screen.SetContent(contentList)
    screen.show()
    
    'main while loop
    while (true)
        msg = wait(0, port)
        if (type(msg) = "roListScreenEvent")
            if (msg.isListItemSelected())
                'calling proper method based on list item selected from main menu
                contentList[msg.GetIndex()].playWithRaf(videoContent)
            end if
        end if
       
    end while
End Sub

'Creation and configuration of video screen.
'@param content [AA] object that has valid data for playing video with roVideoScreen
'@returns [roVideoScreen] video screen object
Function PlayVideoContent(content as Object) as Object
    ' roVideoScreen just closes if you try to resume or seek after ad playback,
    ' so just create a new instance of the screen...
    videoScreen = CreateObject("roVideoScreen")
    videoScreen.SetContent(content)
    ' need a reasonable notification period set if midroll/postroll ads are to be
    ' rendered at an appropriate time
    videoScreen.SetPositionNotificationPeriod(1)
    videoScreen.SetMessagePort(CreateObject("roMessagePort"))
    videoScreen.Show()

    return videoScreen
End Function
